﻿//
// Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
//
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using MindFusion.Scheduling.WebForms;

namespace MindFusion.Scheduling.Samples.CS.CustomAppointment
{
	public class BirthdayAppointmentConverter : ItemConverter
	{
		public BirthdayAppointmentConverter(Calendar calendar)
			: base(calendar)
		{ }

		public override IEnumerable<Type> SupportedTypes
		{
			get
			{
				return new List<Type>() { typeof(BirthdayAppointment) };
			}
		}

		public override IDictionary<string, object> Serialize(object obj, System.Web.Script.Serialization.JavaScriptSerializer serializer)
		{
			BirthdayAppointment bApp = obj as BirthdayAppointment;
			if (bApp != null)
			{
				IDictionary<string, object> json = base.Serialize(obj, serializer);
				if (json != null)
				{
					json.Add("itemType", "custom:bapp");
					json.Add("birthDate", bApp.BirthDate);
					json.Add("person", bApp.BirthdayPerson);
				}
				return json;
			}
			return null;

		}
	}
}
