﻿//
// Copyright (c) 2009-2015, MindFusion LLC - Bulgaria.
//
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Script.Serialization;
using MindFusion.Scheduling;

namespace MindFusion.Scheduling.Samples.CS.CustomAppointment
{
	public partial class _Default : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			if (!IsPostBack)
			{
				if (Schedule.IsClassRegistered("custom:bapp"))
					Schedule.UnregisterClass("custom:bapp");
				Schedule.RegisterItemClass(typeof(BirthdayAppointment), "custom:bapp", 1);

				for (int i = 0; i < 40; i++)
				{
					BirthdayAppointment bDay = new BirthdayAppointment(GenerateRandomBirthDate(), GenerateRandomName());
					Calendar1.Schedule.Items.Add(bDay);
				}

				Appointment normalApp = new Appointment();
				normalApp.HeaderText = "Regular app";
				normalApp.StartTime = DateTime.Now;
				normalApp.EndTime = normalApp.StartTime.AddHours(5);
				Calendar1.Schedule.Items.Add(normalApp);
				BirthdayAppointment todayBApp = new BirthdayAppointment(new DateTime(1984, today.Month, today.Day), "Ringo");
				Calendar1.Schedule.Items.Add(todayBApp);
			}
		}

		private DateTime GenerateRandomBirthDate()
		{
			int year = rnd.Next(1964, 2001);
			int month = rnd.Next(1, 12);
			int day = rnd.Next(1, DateTime.DaysInMonth(year, month));
			return new DateTime(year, month, day);
		}
		private string GenerateRandomName()
		{
			bool male = rnd.Next(0, 5000) % 2 == 0;
			if (male) return mNames[rnd.Next(0, mNames.Length - 1)];
			return fNames[rnd.Next(0, fNames.Length - 1)];
		}

		protected void Calendar1_ItemSerialization(object sender, SerializationEventArgs e)
		{
			e.AddDefaultConverter = true;
			e.Serializer.RegisterConverters(new JavaScriptConverter[] { new BirthdayAppointmentConverter(Calendar1) });
		}

		private static readonly string[] mNames = new string[] {	
			"James", "David", "Christopher", "George","Ronald","John","Richard","Daniel","Kenneth",
			"Anthony","Robert","Charles","Paul","Steven","Kevin","Michael","Joseph","Mark","Edward",
			"Jason","William","Thomas","Donald","Brian","Jeff"};
		private static readonly string[] fNames = new string[] {
			"Mary","Jennifer","Lisa","Sandra","Michelle","Patricia","Maria","Nancy","Donna","Laura",
			"Linda","Susan","Karen","Carol","Sarah","Barbara","Margaret","Betty","Ruth",
			"Kimberly","Elizabeth","Dorothy","Helen","Sharon","Deborah"	};
		private static readonly Random rnd = new Random(DateTime.Now.Millisecond);
		private static readonly DateTime today = DateTime.Today;
	}
}
